/**
 ** Copyright (c) 1999 LAAS/CNRS 
 **
 ** Matthieu Herrb - Tue Feb  9 1999
 **
 ** $Source: /cvs/openrobots/grh2/modules/sick/sickPoster.c,v $
 ** $Revision: 1.1 $
 ** $Date: 2006/01/19 16:45:31 $
 ** 
 **/
#ident "$Id: sickPoster.c,v 1.1 2006/01/19 16:45:31 matthieu Exp $"

#include <stdio.h>
#include <math.h>
#include <tk.h>

#include "portLib.h"
#include "h2errorLib.h"
#include "h2mathLib.h"
#include "auto/sickPosterLib.h"
#include "auto/seglocPosterLib.h"

#include "coord.h"

/*----------------------------------------------------------------------*/

int 
sickAffCallback(ClientData clientData, Tcl_Interp *interp,
		int argc, char *argv[])
{
    SEGLOC_POS transf;	/* transfo de segloc */
    static SICK_SCAN_STR scan;
    static char buf[100];
    double x, y, c, s,  xRobot, yRobot, thetaRobot;
    int i, r;

    /* Supprime anciens points */
    Tcl_Eval(interp, "$Grh2::c delete sickPoints");

    if (seglocLocTransfPosterRead(&transf) == ERROR) {
	Tcl_SetResult(interp, "Error PosterRead", TCL_STATIC);
	return ERROR;
    }
	
    if (sickScanPosterRead(&scan) != OK) {
	Tcl_SetResult(interp, "Error PosterRead", TCL_STATIC);
	return ERROR;
    }
    c = cos(transf.theta);
    s = sin(transf.theta);
    
    /* Corrige la position du robot */
    xRobot = transf.x + c*scan.Header.robot.x - s*scan.Header.robot.y;
    yRobot = transf.y + s*scan.Header.robot.x + c*scan.Header.robot.y;
    thetaRobot = angleLimit(transf.theta + scan.Header.robot.theta);

    printf("Robot: %f %f %f\n", xRobot, yRobot, thetaRobot);
    c = cos(thetaRobot);
    s = sin(thetaRobot);

    r = m_to_pixel(0.02);

    for (i = 0; i < scan.Header.np ; i++) {
	/* Passe en global */
	x = xRobot + scan.CartesianPoints[i].x*c - scan.CartesianPoints[i].y*s;
	y = yRobot + scan.CartesianPoints[i].x*s + scan.CartesianPoints[i].y*c;
	
	sprintf(buf, "$Grh2::c create oval %f %f %f %f -tags sickPoints"
		     " -outline magenta",
		x_m_to_pixel(x)-r, y_m_to_pixel(y)-r,
		x_m_to_pixel(x)+r, y_m_to_pixel(y)+r);
	Tcl_Eval(interp, buf);
    } /* for */
    return TCL_OK;
}

/*----------------------------------------------------------------------*/

int 
Sickposter_Init(Tcl_Interp *interp) 
{
    int code;
    
    code = Tcl_PkgProvide(interp, "SeglocPoster", "0.1");
    if (code != TCL_OK) { 
	return code;
    }

    if (sickPosterInit() != OK) {
	Tcl_SetResult(interp, "Error PosterRead", TCL_STATIC);
	return ERROR;
    }
    if (seglocPosterInit() != OK) {
	Tcl_SetResult(interp, "Error PosterRead", TCL_STATIC);
	return ERROR;
    }
	
    Tcl_CreateCommand(interp, "affSick",
		      sickAffCallback, NULL, NULL);
    return TCL_OK;
}
