/*	$LAAS: grh2.c,v 1.5 2006/06/06 16:17:53 matthieu Exp $ */
/*
 * Copyright (c) 1999-2006 CNRS/LAAS
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#include <tcl.h>
#include <tk.h>

#include "robot.h"
#include "coord.h"

/*----------------------------------------------------------------------*/

    
/**
 ** Widget Tcl Grh2
 **/

int
Grh_Init(Tcl_Interp *interp)
{
    int code;
    Tcl_Obj *obj;

    code = Tcl_PkgProvide(interp, "Grh2", "1.0");
    if (code != TCL_OK) {
	return code;
    }
#ifdef GRH2_DATA_DIR
    /* Ajoute gdhe_library dans auto_path */
    Tcl_Eval(interp, "lappend auto_path " GRH2_DATA_DIR "/tcl");
    Tcl_SetVar(interp, "Grh2dir", GRH2_DATA_DIR, TCL_GLOBAL_ONLY);
#endif
#ifdef notyet
    if (Tcl_PkgRequire(interp, "Grh2::main", "1.0", 0) == NULL) {
	    return TCL_ERROR;
    }
#endif

    /* Initialise variables a` partir de Tcl */
    obj = Tcl_ObjGetVar2(interp, Tcl_NewStringObj("::Grh2::scale", -1), 
			 NULL, TCL_GLOBAL_ONLY);
    if (obj != NULL)
	    Tcl_GetDoubleFromObj(interp, obj, &grh2Scale);
    else
	    grh2Scale = 50;

    /* Lie les variables */
    Tcl_LinkVar(interp, "::Grh2::scale", (char *)&grh2Scale, TCL_LINK_DOUBLE);
    /* Nouveaux items dans le canvas */
    Tk_CreateItemType(&robot);

    return TCL_OK;
}

