/**
 ** Copyright (c) 1999 Matthieu Herrb
 **
 ** $Source: /cvs/openrobots/grh2/src/traj.c,v $
 ** $Revision: 1.1 $
 ** $Date: 2006/01/19 16:45:31 $
 ** 
 **/
#ident "$Id: traj.c,v 1.1 2006/01/19 16:45:31 matthieu Exp $"

#include <tcl.h>
#include <tk.h>

#include "robot.h"

/*----------------------------------------------------------------------*/

typedef struct GRH2_ROBOT_ITEM {
    Tk_Item header;
    double x, y, theta;
    XColor *fgColor;
    XColor *bgColor;
    GC gc;
    char *type;
} GRH2_ROBOT_ITEM;

/*----------------------------------------------------------------------*/

static Tk_ConfigSpec grh2RobotConfigSpecs[] = {
    { TK_CONFIG_COLOR, "-foreground", "foreground", "Foreground",
      "black", Tk_Offset(GRH2_ROBOT_ITEM, fgColor), 0 },
    { TK_CONFIG_COLOR, "-background", "background", "Background",
      "white", Tk_Offset(GRH2_ROBOT_ITEM, bgColor), 0 },
    { TK_CONFIG_DOUBLE, "-angle", "angle", "Angle",
      "0.0", Tk_Offset(GRH2_ROBOT_ITEM, theta), 0 },
    { TK_CONFIG_STRING, "-type", "type", "Type",
      "h2", Tk_Offset(GRH2_ROBOT_ITEM, type), 0 },
    { TK_CONFIG_END, NULL, NULL, NULL, NULL, 0, 0 }
};

/*----------------------------------------------------------------------*/

static int
grh2RobotCreate(Tcl_Interp *interp, Tk_Canvas canvas, Tk_Item *itemPtr,
		int argc, char **argv)
{
    return TCL_OK;
}

/*----------------------------------------------------------------------*/

static int
grh2RobotConfig(Tcl_Interp *interp, Tk_Canvas canvas, Tk_Item *itemPtr,
		int argc, char **argv, int flags)
{
    return TCL_OK;
}

/*----------------------------------------------------------------------*/

static int
grh2RobotCoord(Tcl_Interp *interp, Tk_Canvas canvas, Tk_Item *itemPtr,
	       int argc, char **argv)
{
    return TCL_OK;
}

/*----------------------------------------------------------------------*/

static void
grh2RobotDelete(Tk_Canvas canvas, Tk_Item *itemPtr, Display *display)
{
}

/*----------------------------------------------------------------------*/

static void
grh2RobotDisplay(Tk_Canvas canvas, Tk_Item *itemPtr, Display *display,
		 Drawable dst, int x, int y, int width, int height)
{
}

/*----------------------------------------------------------------------*/

static double
grh2RobotPoint(Tk_Canvas canvas, Tk_Item *itemPtr, double *pointPtr)
{
    return 0.0;
}

/*----------------------------------------------------------------------*/

static int
grh2RobotArea(Tk_Canvas canvas, Tk_Item *itemPtr, double *rectPtr)
{
    return 0;
}

/*----------------------------------------------------------------------*/

static int
grh2RobotPostscript(Tcl_Interp *interp, Tk_Canvas canvas, Tk_Item *itemPtr,
		    int prepass)
{
    return TCL_OK;
}

/*----------------------------------------------------------------------*/

static void
grh2RobotScale(Tk_Canvas canvas, Tk_Item *itemPtr, 
	       double originX, double originY, double scaleX, double scaleY)
{
}

/*----------------------------------------------------------------------*/

static void
grh2RobotTranslate(Tk_Canvas canvas, Tk_Item *itemPtr, 
		   double deltaX, double deltaY)
{
}

/*----------------------------------------------------------------------*/


Tk_ItemType robot = {
    "robot",
    sizeof(GRH2_ROBOT_ITEM),
    grh2RobotCreate,
    grh2RobotConfigSpecs,
    grh2RobotConfig,
    grh2RobotCoord,
    grh2RobotDelete,
    grh2RobotDisplay,
    0,
    grh2RobotPoint,
    grh2RobotArea,
    grh2RobotPostscript,
    grh2RobotScale,
    grh2RobotTranslate,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL
};

