#!/bin/sh
# the next line restarts using rwish \
exec elwish "$0" "$@"

package provide Grh2::humsim 1.0

namespace eval Grh2 {
    variable toolbar
    variable c
}


# find out base directory of g2h2
#set dir [file join [ file dirname $argv0 ] .. ]
set dir "../"
set ::Grh2::dir $dir
puts $dir 

set picoHost jido-arm
set tclHost jido-arm


set auto_path "${auto_path} ."

# Required packages
package require Grh2
package require genom
package require Grh2::canvas 
package require Grh2::coord
package require Grh2::entrydialog
package require Grh2::scout
package require Grh2::segkit
package require xml


# load BWidget
lappend auto_path $dir/tcl/BWidget
puts $auto_path
package require BWidget


# load various library functions
#source $dir/modules/segkit/segkit.tcl
#source $dir/tcl/canvas.tcl
#source $dir/tcl/coord.tcl
#source $dir/tcl/tk_entrydialog.tcl


# Create the ::Grh2::segloc namespace
# namespace eval ::Grh2::segloc {
#     variable segments
#     variable currentFile
# }

namespace eval ::Grh2::humsim { 
    

    #----------------------------------------------------------------------
    #
    # Set up main window
    #
    proc mainWindow { } {
	global grh2
	global mouseInfos

	set descmenu {
	    "&File" all file 0 {
		{command "E&xit" {} "Exit Grh2" {} -command Grh2::exit}
		{command "&Load  .." {} "Load humans" {} -command Grh2::humsim::loadHumans}
		{command "&Save" {} "Save humans" {} -command Grh2::humsim::saveHumans}
		{command "&Save as..." {} "Save humans as .." {} -command Grh2::humsim::saveHumansAs}
	    }
	    "&Mode" all edit 0 {
		{command "&Edit mode" {} "Edit person" {} \
		     -command  Grh2::humsim::edit }
		{command "&Add mode" {} "Add person(s)" {} \
		     -command Grh2::humsim::add}
		{command "&Delete mode" {} "Delete person(s)" {} \
		     -command Grh2::humsim::delete}
		
		
	    }
	    
	    "&Actions" all tools 0 {	
		{command "&Read from genom" {} "Read all informations from genom" {} \
		     -command "::Grh2::humsim::loadFromHuman " }
		{command "&Send to genom" {} "Send all informations to genom" {} \
		     -command "Grh2::humsim::sendInfos " }
		{command "Remove &Selected" {} "Remove all selected persons" {} \
		     -command Grh2::humsim::removeAllSelected}
		{command "Remove &All" {} "Remove all persons" {} \
		     -command "Grh2::humsim::removeAll 0"}
	    }

	    "&View" all tools 0 {
		{command "Zoom &in" {} "Zoom in" {} \
		     -command Grh2::humsim::zoomIn }
		{command "Zoom &out" {} "Zoom out" {} \
		     -command Grh2::humsim::zoomOut }
	    }
	    "&Help" all help 0 { 
		{command "&About" {} "About Grh2" {} -command Grh2::humsim::aboutBox}
	    }
	}
	set ::Grh2::mainframe [ MainFrame .mainframe \
				    -menu $descmenu \
				    -textvariable Grh2::status \
				    -progressvar Grh2::progress]
	# Toolbar
	set Grh2::toolbar [$Grh2::mainframe addtoolbar]

	set bbox [ButtonBox $Grh2::toolbar.bbox1 -spacing 4 -padx 1 -pady 1]
	$bbox add -image [Bitmap::get open] \
	    -highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
	    -helptext "Load humans" -command Grh2::humsim::loadHumans

	pack $bbox -side left -anchor w

	set bbox [ButtonBox $Grh2::toolbar.bbox12 -spacing 4 -padx 1 -pady 1]
	$bbox add -image [Bitmap::get save] \
	    -highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
	    -helptext "Save humans" -command Grh2::humsim::saveHumans

	pack $bbox -side left -anchor w

	set sep [Separator $Grh2::toolbar.sep1 -orient vertical -relief ridge ]
	pack $sep -side left -fill y -padx 5 -anchor w
	
	set bbox [ButtonBox $Grh2::toolbar.bbox2 -spacing 4 -padx 1 -pady 1]
	$bbox add -image [Bitmap::get $::Grh2::dir/icons/zoomIn] \
	    -highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
	    -helptext "Zoom in" -command Grh2::humsim::zoomIn
	$bbox add -image [Bitmap::get $::Grh2::dir/icons/zoomOut] \
	    -highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
	    -helptext "Zoom out" -command Grh2::humsim::zoomOut
	pack $bbox -side left -anchor w

	set sep [Separator $Grh2::toolbar.sep2 -orient vertical -relief ridge ]
	pack $sep -side left -fill y -padx 5 -anchor w

	#     set bbox [ButtonBox $Grh2::toolbar.bbox3 -spacing 4 -padx 1 -pady 1]
	#     $bbox add -image [Bitmap::get $::Grh2::dir/icons/delete] \
	    #         -highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
	    # 	-helptext "Delete selected persons" -command Grh2::humsim::removeAllSelected
	#     pack $bbox -side left -anchor w

	set bbox [ButtonBox $Grh2::toolbar.bbox4 -spacing 4 -padx 1 -pady 1]


	$bbox add -image [Bitmap::get $::Grh2::dir/icons/get] \
	    -highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
	    -helptext "Read human from Genom" -command "::Grh2::humsim::loadFromHuman"
	$bbox add -image [Bitmap::get $::Grh2::dir/icons/send] \
	    -highlightthickness 0 -takefocus 0 -relief raised -borderwidth 1 -padx 1 -pady 1 \
	    -helptext "Update infos on Genom" -command "Grh2::humsim::sendInfos"
	pack $bbox -side left -anchor w




	$Grh2::mainframe addindicator -textvariable mouseInfos  -width 20
	$Grh2::mainframe addindicator -text " (c) LAAS/CNRS 1999-2007 " 
	# Canvas
	set frame [$Grh2::mainframe getframe]
	# $frame configure  -class ScrolledCanvas 
	set ::Grh2::c [::Grh2::scrolledCanvas $frame]
	pack $Grh2::mainframe -fill both -expand yes
    }

    ###----------------------------------------------------------------------
    ##
    ## Zoom
    ##
    # 
    # In
    # 
    proc zoomIn {} {
	::Grh2::zoominProc 320 200
    }

    #
    # Out
    #
    proc zoomOut {} {
	::Grh2::zoomoutProc 320 200
    }


    ###----------------------------------------------------------------------
    ##
    ## Modes bindings
    ##

    #
    # edit mode
    #
    proc editMode {} {
	bind $Grh2::c <ButtonPress-1> {Grh2::humsim::showPos $Grh2::c %x %y; .canvasmenu unpost ; .humanmenu unpost}
	bind $Grh2::c <ButtonPress-3> "Grh2::humsim::CanvasContextualMenu $Grh2::c %x %y"
	bind $Grh2::c <Motion> "Grh2::humsim::showPos  $Grh2::c %x %y"
	$Grh2::c configure -cursor "left_ptr"
	$Grh2::c bind human <Enter> "Grh2::humsim::hilightHuman $Grh2::c"
	$Grh2::c bind human <ButtonPress-1> "Grh2::humsim::selectHuman $Grh2::c"
	$Grh2::c bind human <Double-ButtonPress-1> "Grh2::humsim::editCurentHuman $Grh2::c"
	$Grh2::c bind human <Leave> "Grh2::humsim::restoreHuman $Grh2::c"
	$Grh2::c bind human <B1-Motion> "Grh2::humsim::move $Grh2::c %x %y"
	$Grh2::c bind human <Control-B1-Motion> "Grh2::humsim::rotate $Grh2::c %x %y"
    }
    proc moveMode {id} {
	bind $Grh2::c <Motion> "Grh2::humsim::showPos  $Grh2::c %x %y;Grh2::humsim::moveId $Grh2::c $id %x %y"
	bind $Grh2::c <ButtonPress-1> {Grh2::humsim::editMode}
    }

    proc rotateMode {id} {
	bind $Grh2::c <Motion> "Grh2::humsim::rotateId $Grh2::c $id %x %y"
	bind $Grh2::c <ButtonPress-1> {Grh2::humsim::editMode}
    }

    proc addMode {} {
	$Grh2::c configure -cursor "cross"
	bind $Grh2::c <ButtonPress-1> {Grh2::humsim::placeHuman $Grh2::c %x %y }
	bind $Grh2::c <ButtonPress-2> {Grh2::humsim::editMode}

    }

    proc deleteMode {} {
	$Grh2::c configure -cursor "pirate"
	bind $Grh2::c <ButtonPress-1> {Grh2::humsim::removeHuman $Grh2::c %x %y}
	bind $Grh2::c <ButtonPress-2> {Grh2::humsim::editMode}
    }

    #showPos
    #Display curent cursor position in the world absolute frame
    # 
    proc showPos {c x y} {

	global mouseInfos

	set cx [$Grh2::c canvasx $x]
	set cy [$Grh2::c canvasy $y]

	set xm [Grh2::x_pixel_to_m $cx]
	set ym [Grh2::y_pixel_to_m $cy]
	
	$Grh2::mainframe configure -textvariable  "$xm $ym"

	#puts "$x $y"
	set xm [format %.2f $xm]
	set ym [format %.2f $ym]
	
	set mouseInfos "x$xm y$ym"
    }



    #
    # "hover" mode: highlight
    #
    proc hilightHuman {c} {
	global stateColor

	set id [$c find withtag current]
	
	$c itemconfigure $id -fill $stateColor(current)
    }

    #
    # "hover" mode: restore original state
    #
    proc restoreHuman {c} {
	global stateColor humanState
	
	set id [$c find withtag current]
	
	$c itemconfigure $id -fill $stateColor($humanState($id))
    }

    #
    # select segment under the pointer
    #   
    proc selectHuman {c} {
	global stateColor humanState selected humanGenId

	set id [$c find withtag current]
	if { $humanGenId($id) < 0} {
	    if  {! [info exists selected($id)]} {
		set humanState($id) selected
		$c itemconfigure $id -fill $stateColor(selected)
		set selected($id) true
		
	    } else {
		set humanState($id) normal
		unset selected($id)
	    }
	}
    }
    #newGenId
    # return a nex ID for genom human module
    proc newGenId { } {
	global lastGenId
	set lastGenId [expr $lastGenId-1]
	return $lastGenId
    }

    #placeHuman
    #create a human in the x , y position of the canvas c
    #
    proc placeHuman {c x y} {
	global humanState human humanName humanMotion humanDistance humanLeftArm humanRightArm humanLook humanlhPos humanrhPos humanhPos humanVel stateColor humanllPos humanrlPos humanGenId humanPosture
	

	set mx [expr [winfo pointerx .] -10]
	set my [winfo pointery .]



	set cx [$c canvasx $x]
	set cy [$c canvasy $y]
	puts "place Human $cx $cy"
	set xm [Grh2::x_pixel_to_m $cx]
	set ym [Grh2::y_pixel_to_m $cy] 
	puts " --> $xm $ym"

	set id [$c create robot $cx $cy 0 -type xr4000 -fill red -tag human]
	destroy .humanInfos
	set human($id) "Unknown"
	set humanName($id) [$c create text $cx $cy -text "Unknown"   -tag humanName]
	set humanState($id) normal 
	#defaults values
	set humanLeftArm($id) "HUMAN_ARM_UNKNOWN"
	set humanRightArm($id) "HUMAN_ARM_UNKNOWN"
	set humanLook($id) "HUMAN_LOOK_UNKNOWN"
	set humanMotion($id) "HUMAN_MOTION_UNKNOWN"
	set humanDistance($id) "HUMAN_DISTANCE_UNKNOWN"
	set humanPosture($id) "HUMAN_POSTURE_UNKNOWN"
	set humanlhPos($id,x) 0.0
	set humanlhPos($id,y) 0.8
	set humanlhPos($id,z) 1.2
	set humanrhPos($id,x) 0.0
	set humanrhPos($id,y) -0.8
	set humanrhPos($id,z) 1.2
	set humanhPos($id,x)  0.0
	set humanhPos($id,y)  0.0
	set humanhPos($id,z) 1.7
	set humanllPos($id,x) 0.0
	set humanllPos($id,y) 0.2
	set humanllPos($id,z) 0.2
	set humanrlPos($id,x) 0.0
	set humanrlPos($id,y) -0.2
	set humanrlPos($id,z) 0.2
	set humanVel($id) 0.0    
	set humanGenId($id) [newGenId]

	#Display window to modify those informations
	humanInfosWindow $c $id $mx $my  
	#Set the color to normal state ( sometimes it start in selected state whereas it is not selected) 
	$c itemconfigure $id -fill $stateColor(normal)

    }

    proc duplicateHumanId {c id} {
	global human humanState humanName humanMotion humanDistance humanLeftArm humanRightArm humanLook humanInfos humanlhPos humanrhPos humanhPos humanVel humanllPos humanrlPos humanGenId humanPosture

	set x [lindex [$Grh2::c coords $id] 0 ]
	set y [lindex [$Grh2::c coords $id] 1 ]
	set theta [lindex [$Grh2::c coords $id] 2 ]

	set idN [$Grh2::c create robot $x $y $theta -type xr4000 -tag human]
	set human($idN) $human($id)
	set humanState($idN) normal
	set humanName($idN) [$Grh2::c create text $x $y  -text $human($idN) -tag humanName]

	set humanLeftArm($idN)  $humanLeftArm($id)
	set humanRightArm($idN)  $humanRightArm($id)
	set humanLook($idN) $humanLook($id)
	set humanMotion($idN) $humanMotion($id)
	set humanDistance($idN) $humanDistance($id)
	set humanPosture($idN) $humanPosture($id)
	set humanlhPos($idN,x) $humanlhPos($id,x)
	set humanlhPos($idN,y) $humanlhPos($id,y)
	set humanlhPos($idN,z) $humanlhPos($id,z)
	set humanrhPos($idN,x) $humanrhPos($id,x)
	set humanrhPos($idN,y) $humanrhPos($id,y)
	set humanrhPos($idN,z) $humanrhPos($id,z)
	set humanhPos($idN,x) $humanhPos($id,x)
	set humanhPos($idN,y) $humanhPos($id,y)
	set humanhPos($idN,z) $humanhPos($id,z)
	set humanllPos($idN,x) $humanllPos($id,x)
	set humanllPos($idN,y) $humanllPos($id,y)
	set humanllPos($idN,z) $humanllPos($id,z)
	set humanrlPos($idN,x) $humanrlPos($id,x)
	set humanrlPos($idN,y) $humanrlPos($id,y)
	set humanrlPos($idN,z) $humanrlPos($id,z)
	set humanGenId($idN) $humanGenId($id)
	set humanVel($idN) $humanVel($id)
	


	moveMode $idN

    } 




    #----------------------------------------------------------------------

    #
    # Marketing
    #
    proc aboutBox {} {



	tk_messageBox -icon info -type ok -title "About humsim" \
	    -message  "Grh2 - humsim\n\nCopyright (c) 1999-2007 LAAS/CNRS"
    }

    #----------------------------------------------------------------------



    #----------------------------------------------------------------------
    #
    # Display contextuals menus
    #

    #initialize menus
    proc PrepareContextualMenu {} { 
	

	# Create human menu
	menu  .humanmenu -tearoff 0
	.humanmenu add command -label {Edit informations} 
	.humanmenu add command -label {Move} 
	.humanmenu add command -label {Rotate} 
	.humanmenu add command -label {Delete human} 
	.humanmenu add command -label {Duplicate human} 
	#  .humanmenu add command -label {Send infos to Genom} 
	# Create canvas menu
	menu .canvasmenu -tearoff 0 
	.canvasmenu add command -label {Add human here} 


    }

    #display canvas menu
    proc CanvasContextualMenu {c cX cY} { 
	global humanState human humanGenId

	set mx [expr [winfo pointerx .] -10]
	set my [winfo pointery .]

	set id [$c find withtag current]

	#display human menu if cliked on human instead of standart menu
	if  {[info exists human($id)]} {
	    if { $humanGenId($id) < 0} {
		.humanmenu entryconfigure 0 -command "Grh2::humsim::editHumanId $c $id  " 
		.humanmenu entryconfigure 1 -command "Grh2::humsim::moveMode $id" 
 		.humanmenu entryconfigure 2 -command "Grh2::humsim::rotateMode $id"
		.humanmenu entryconfigure 3 -command "Grh2::humsim::removeHumanId $c $id 0 " 
		.humanmenu entryconfigure 4 -command "Grh2::humsim::duplicateHumanId $c $id " 
		
		#	.humanmenu entryconfigure 4 -command "Grh2::humsim::sendInfos " 
		.humanmenu post $mx $my 

		.canvasmenu unpost
	    }
	} else {
	    .canvasmenu entryconfigure 0 -command "Grh2::humsim::placeHuman $c $cX $cY " 
	    .canvasmenu post $mx $my
	    .humanmenu unpost
	}
	
    }

    #----------------------------------------------------------------------
    #
    # Display window
    #

    #humanInfosWindow
    #Display window with all human informations

    proc humanInfosWindow {c id x y } { 
	global human humanName humanMotion humanDistance humanLeftArm humanRightArm humanLook humanlhPos humanrhPos humanhPos humanVel humanllPos humanrlPos humanGenId humanPosture
	if { $humanGenId($id) < 0} {
	    toplevel .humanInfos

	    wm title .humanInfos "Human informations : $human($id) "

	    wm resizable .humanInfos 0 0

	    wm protocol .humanInfos  WM_DELETE_WINDOW  "Grh2::humsim::humanInfosWindowValid $c $id "
	    wm geometry .humanInfos +$x+$y 


	    #-- HUMAN ID

	    label .humanInfos.nameLbl -text Name
	    entry .humanInfos.name -justify left -textvariable human($id) -width 15

	    label .humanInfos.idLbl -text Id
	    label .humanInfos.id -justify left -textvariable humanGenId($id)

	    grid .humanInfos.nameLbl - .humanInfos.name - .humanInfos.idLbl .humanInfos.id 
	    grid  configure  .humanInfos.nameLbl -sticky e
	    grid  configure  .humanInfos.id -sticky w

	    #-- NUMERICAL DATA

	    #HEAD POS    
	    label .humanInfos.hPosTitlelbl -text "HEAD"
	    label .humanInfos.hPoslblx -text X

	    scale .humanInfos.hPosx  -variable humanhPos($id,x) -orient horizontal -from -0.5 -to 0.5 -resolution 0.1

	    label .humanInfos.hPoslbly -text Y
	    scale .humanInfos.hPosy  -variable humanhPos($id,y) -orient horizontal -from -0.5 -to 0.5 -resolution 0.1


	    label .humanInfos.hPoslblz -text Z
	    scale .humanInfos.hPosz  -variable  humanhPos($id,z) -orient horizontal -from 1 -to 2.5 -resolution 0.1

	    grid .humanInfos.hPosTitlelbl - - - - -
	    grid  x x .humanInfos.hPoslblx .humanInfos.hPosx x x
	    grid  x x .humanInfos.hPoslbly .humanInfos.hPosy x x

	    label .humanInfos.lTitlelbl -text "left"
	    label .humanInfos.rTitlelbl -text "right"

	    grid .humanInfos.lTitlelbl - .humanInfos.hPoslblz .humanInfos.hPosz  .humanInfos.rTitlelbl -  
	    grid  configure  .humanInfos.lTitlelbl -sticky w
	    grid  configure  .humanInfos.rTitlelbl -sticky e

	    #LEFT HAND POS
	    label .humanInfos.lhPoslblx -text X

	    scale .humanInfos.lhPosx  -variable humanlhPos($id,x) -orient horizontal -from -1 -to 1 -resolution 0.1


	    label .humanInfos.lhPoslbly -text Y
	    scale .humanInfos.lhPosy  -variable humanlhPos($id,y) -orient horizontal -from -1 -to 1 -resolution 0.1


	    label .humanInfos.lhPoslblz -text Z
	    scale .humanInfos.lhPosz  -variable  humanlhPos($id,z) -orient horizontal -from 1 -to 2.5 -resolution 0.1


	    #RIGHT HAND POS
	    label .humanInfos.hTitlelbl -text "<--- HANDS --->"
	    label .humanInfos.rhPoslblx -text X
	    scale .humanInfos.rhPosx  -variable humanrhPos($id,x) -orient horizontal -from -1 -to 1 -resolution 0.1

	    label .humanInfos.rhPoslbly -text Y
	    scale .humanInfos.rhPosy  -variable humanrhPos($id,y) -orient horizontal -from -1 -to 1 -resolution 0.1

	    label .humanInfos.rhPoslblz -text Z
	    scale .humanInfos.rhPosz  -variable humanrhPos($id,z) -orient horizontal -from 1 -to 2.5 -resolution 0.1
	    entry .humanInfos.test -justify left -textvariable humanrhPos($id,z)

	    grid  .humanInfos.lhPoslblx .humanInfos.lhPosx  .humanInfos.hTitlelbl - .humanInfos.rhPoslblx .humanInfos.rhPosx
	    grid  .humanInfos.lhPoslbly .humanInfos.lhPosy x x .humanInfos.rhPoslbly .humanInfos.rhPosy 
	    grid  .humanInfos.lhPoslblz .humanInfos.lhPosz x x .humanInfos.rhPoslblz .humanInfos.rhPosz
	    
	    #Velocity
	    label .humanInfos.vellbl -text "velocity (m/s)"
	    scale .humanInfos.vel  -variable  humanVel($id) -orient horizontal -from 0 -to  10 -resolution 0.1
	    grid x .humanInfos.vellbl - .humanInfos.vel x x

	    

	    #LEFT LEG POS
	    label .humanInfos.legsTitlelbl -text "<--- LEGS --->"
	    label .humanInfos.llPoslblx -text X

	    scale .humanInfos.llPosx  -variable humanllPos($id,x) -orient horizontal -from -1 -to 1 -resolution 0.1


	    label .humanInfos.llPoslbly -text Y
	    scale .humanInfos.llPosy  -variable humanllPos($id,y) -orient horizontal -from -1 -to 1 -resolution 0.1


	    label .humanInfos.llPoslblz -text Z
	    scale .humanInfos.llPosz  -variable  humanllPos($id,z) -orient horizontal -from 0 -to 1 -resolution 0.1

	    #RIGHT LEG POS
	    label .humanInfos.rlPoslblx -text X
	    scale .humanInfos.rlPosx  -variable humanrlPos($id,x) -orient horizontal -from -1 -to 1 -resolution 0.1

	    label .humanInfos.rlPoslbly -text Y
	    scale .humanInfos.rlPosy  -variable humanrlPos($id,y) -orient horizontal -from -1 -to 1 -resolution 0.1

	    label .humanInfos.rlPoslblz -text Z
	    scale .humanInfos.rlPosz  -variable humanrlPos($id,z) -orient horizontal -from 0 -to 1 -resolution 0.1


	    # Legs on grid
	    grid  .humanInfos.llPoslblx .humanInfos.llPosx .humanInfos.legsTitlelbl - .humanInfos.rlPoslblx .humanInfos.rlPosx
	    grid  .humanInfos.llPoslbly .humanInfos.llPosy x x .humanInfos.rlPoslbly .humanInfos.rlPosy 
	    grid  .humanInfos.llPoslblz .humanInfos.llPosz x x .humanInfos.rlPoslblz .humanInfos.rlPosz
	    
	    #STATE
	    set comboboxWidth 27

	    label .humanInfos.motionLbl -text Motion
	    ComboBox .humanInfos.motion -values [list HUMAN_MOTION_UNKNOWN HUMAN_MOTION_STOP HUMAN_MOTION_MOVING HUMAN_MOTION_APPROACHING ] -textvariable humanMotion($id) -editable 0 -width $comboboxWidth
	    grid .humanInfos.motionLbl - .humanInfos.motion - - -
	    grid  configure  .humanInfos.motionLbl -sticky e
	    grid  configure  .humanInfos.motion -sticky w
	    
	    label .humanInfos.lookLbl -text Look
	    ComboBox .humanInfos.look -values [list HUMAN_LOOK_ROBOT HUMAN_LOOK_ELSEWHERE HUMAN_LOOK_UNKNOWN] -textvariable humanLook($id) -editable 0  -width $comboboxWidth
	    grid .humanInfos.lookLbl - .humanInfos.look - - -
	    grid  configure  .humanInfos.lookLbl -sticky e
	    grid  configure  .humanInfos.look -sticky w

	    label .humanInfos.distanceLbl -text Distance
	    ComboBox .humanInfos.distance -values [list HUMAN_DISTANCE_CLOSE HUMAN_DISTANCE_MIDDLE HUMAN_DISTANCE_FAR HUMAN_DISTANCE_UNKNOWN] -textvariable humanDistance($id) -editable 0   -width $comboboxWidth
	    grid  .humanInfos.distanceLbl - .humanInfos.distance - - -
	    grid  configure  .humanInfos.distanceLbl -sticky e
	    grid  configure  .humanInfos.distance -sticky w

	    label .humanInfos.leftArmLbl -text LeftArm
	    ComboBox .humanInfos.leftArm -values [list HUMAN_ARM_TIGHT HUMAN_ARM_OTHER HUMAN_ARM_UNKNOWN] -textvariable humanLeftArm($id) -editable 0   -width $comboboxWidth
	    grid  .humanInfos.leftArmLbl - .humanInfos.leftArm - - -
	    grid  configure  .humanInfos.leftArmLbl -sticky e
	    grid  configure  .humanInfos.leftArm -sticky w

	    label .humanInfos.rightArmLbl -text RightArm
	    ComboBox .humanInfos.rightArm -values [list HUMAN_ARM_TIGHT HUMAN_ARM_OTHER HUMAN_ARM_UNKNOWN] -textvariable humanRightArm($id) -editable 0   -width $comboboxWidth
	    grid  .humanInfos.rightArmLbl - .humanInfos.rightArm - - -
	    grid  configure  .humanInfos.rightArmLbl -sticky e
	    grid  configure  .humanInfos.rightArm -sticky w

	    label .humanInfos.postureLbl -text Posture
	    ComboBox .humanInfos.posture -values [list HUMAN_POSTURE_STOOD HUMAN_POSTURE_SEATED HUMAN_POSTURE_UNKNOWN] -textvariable humanPosture($id) -editable 0   -width $comboboxWidth
	    grid  .humanInfos.postureLbl - .humanInfos.posture - - -
	    grid  configure  .humanInfos.postureLbl -sticky e
	    grid  configure  .humanInfos.posture -sticky w

	    button .humanInfos.ok -text "OK" -command "Grh2::humsim::humanInfosWindowValid $c $id"
	    button .humanInfos.kill -text "Delete human" -command "Grh2::humsim::humanInfosWindowDelete  $c $id " 
	    button .humanInfos.send -text "Update Genom" -command "Grh2::humsim::sendInfos  " 

	    grid .humanInfos.ok - .humanInfos.send  - .humanInfos.kill -

#	    grid rowconfigure . {0 1 2 3 4} -weight 1 -minsize 40
#	    grid columnconfigure . {0 1 2 3} -weight 1 -minsize 40

	}
    }

    #----------------------------------------------------------------------
    #
    # Callbacks procedures
    #


    #humanInfosWindowDelete
    # Callback when clicked on "delete human"
    proc  humanInfosWindowDelete {c id } {
	if {[Grh2::humsim::removeHumanId $c $id 0]} { 
	    destroy .humanInfos
	}
    }
    #humanInfosWindowValid
    #callback when clicked on "valid"
    #update name widget and verify if not null
    proc  humanInfosWindowValid { c id  } {
	global human humanName

	if {[string length $human($id)] > 0} { 
	    destroy .humanInfos;
	    if {[ info exists humanName($id) ]} {
		$c itemconfigure $humanName($id) -text $human($id)
	    }
	} else {
	    puts "Name should not be null "
	}

    }







    # editCurentHuman
    # Edit human under the cursor 
    #
    proc editCurentHuman {c} {
	set id [$c find withtag current]
	editHumanId $c $id
    }

    # editHumanId 
    # Edit human with his ID
    # 
    proc editHumanId {c id} {
	set mx [expr [winfo pointerx .] -10]
	set my [winfo pointery .]
	destroy .humanInfos
	humanInfosWindow $c $id $mx $my     
    }



    # Remove all human on the map
    # returns 
    #  1 : OK
    #  0 : Canceled
    proc removeAll {fullDelete {quiet 0} } {
	global human
	if {$quiet == 0 } {
	    set answer [MessageDlg::create .msgDlg \
			    -message "You are about to delete All human on the map ! " \
			    -icon warning \
			    -type okcancel ]
	} else {
	    set answer= 0;
	}
	if {$answer==0} {	    
	    puts "Start cleaning all humans... "

	    foreach id [array names human] {
		set name $human($id)
		if {[removeHumanId $Grh2::c $id $fullDelete 1] } {
		    puts  "Human $name removed ."
		} else {
		    puts  "Warning: $name not removed ." 
		}
	    }
	    puts "Cleaning all humans ended ."
	    return 1
	}
	return 0
    }
    # removeAllSelected
    # Remove all selected human on the map
    # returns 
    #  1 : OK
    #  0 : Canceled by user
    proc removeAllSelected { } {
	global human selected
	set answer [MessageDlg::create .msgDlg \
			-message "You are about to delete All human selected on the map (in red) ! " \
			-icon warning \
			-type okcancel ]
	if {$answer==0} {
	    puts "Start cleaning all selected humans... "
	    foreach id [array names selected] {
		set name $human($id)
		if {[removeHumanId $Grh2::c $id 0 1 ]} {
		    puts  "Human $name removed ."
		} else {
		    puts  "Warning: $name not removed ." 
		}
	    } 
	    puts "Cleaning all selected humans ended ."
	    return 1
	} 
	return 0
    }

    #removeHuman
    #Remove human under the cursor
    #
    proc removeHuman {c x y} {
	set id [$c find withtag current]
	return [removeHumanId $c $id 0]
    }

    #removeHumanId
    #remove human whith his ID
    #
    proc removeHumanId {c id fullDelete {quiet 0}} {
	global human humanName humanMotion humanDistance humanLeftArm humanRightArm humanLook humanlhPos humanrhPos humanhPos humanVel humanllPos humanrlPos humanGenId humanDeleted humanPosture
	#We must be sure that the human Info window is not opened , 
	#because if it is the case, when we unset variables modified by this window
	#they are automaticaly reset to values of the window, and  human will not be  
	#totally removed
	destroy .humanInfos

	#remove only human, not the world
	if [info exists human($id) ] { 
	    if {! $quiet } {
		set answer [MessageDlg::create .msgDlg \
				-message "You will delete human named : $human($id) (id:$humanGenId($id)) " \
				-icon warning \
				-type okcancel ]
	    } else {
		set answer 0
	    }

	    if {$answer == 0 } {
		$c delete $id
		catch { $c delete $humanName($id) } 
		catch { unset selected($id) }

		catch { unset humanName($id) } 
		catch { unset humanLeftArm($id) } 
		catch { unset humanRightArm($id) } 
		catch { unset humanLook($id) } 
		catch { unset humanMotion($id) } 
		catch { unset humanDistance($id) } 
		catch { unset humanPosture($id) } 
		catch { unset humanlhPos($id,x)  }
		catch { unset humanlhPos($id,y)  }
		catch { unset humanlhPos($id,z)  }
		catch { unset humanrhPos($id,x)  }
		catch { unset humanrhPos($id,y)  }
		catch { unset humanrhPos($id,z)  }	
		catch { unset humanhPos($id,x)  }
		catch { unset humanhPos($id,y)  }
		catch { unset humanhPos($id,z)  }
		catch { unset humanllPos($id,x)  }
		catch { unset humanllPos($id,y)  }
		catch { unset humanllPos($id,z)  }
		catch { unset humanrlPos($id,x)  }
		catch { unset humanrlPos($id,y)  }
		catch { unset humanrlPos($id,z)  }
		catch { unset humanVel($id)}
		if {$fullDelete == 1} {
		    catch { unset humanGenId($id)}
		    catch { unset human($id)} 
		    catch { unset humanDeleted($id)} 
		} else {
		    #Not very thing is unset : we keep those information for delting in genom 
		    #they should be unset, when the delete request succeed		    
		    set humanDeleted($id) 1
		}
		return 1
	    }
	}
	return 0
    }


    proc add {} {
	#puts "Add human"
	addMode
    }
    
    proc delete {} { 
	#puts "Delete human"
	deleteMode
    }

    proc edit {} {
	#puts "Edit human"
	editMode
    }

    # move
    # Move human under the cursor
    # 
    proc move {c x y} {
	set id [$c find withtag current]
	moveId $c $id $x $y
    }

    # moveId
    # Move human with his ID
    proc moveId {c id x y } {
	global human humanName humanPos humanGenId
	if {$humanGenId($id) < 0 } {
	    set cx [$c canvasx $x]
	    set cy [$c canvasy $y]
	    set old [$c coords $id]
	    
	    $c coords $id $cx $cy [lindex $old 2]
	    $c coords $humanName($id) $cx $cy

	    #puts "Move human $id $human($id) :$cx,$cy "
	}
    }

    # rotate
    # Rotate human under the cursor
    #
    proc rotate {c x y} {
	set id [$c find withtag current]
	rotateId $c $id $x $y
    }
    
    # rotateId
    # Rotate human with his Id
    #
    proc rotateId {c id x y } {
	global human humanName humanPos humanGenId
	if {$humanGenId($id) < 0 } {
	    set x [$c canvasx $x]
	    set y [$c canvasy $y]
	    set center [$c coords $id]
	    set cx [lindex $center 0]
	    set cy [lindex $center 1]
	    set cangle [lindex $center 2]
	    set angle [expr 3.1415926535 - atan2($cy - $y, $cx - $x)]
	    #puts "Rotate human $human($id) $angle"
	    $c coords $id $cx $cy $angle
	}
    }


    # loadHumans
    # Ask the user which file will be opened
    #
    proc loadHumans { } { 
	global saveFile

	set types {  
	    {{humsim Files}        {.humsim}            }
	    {{All Files}        *             }
	}  
	set file [tk_getOpenFile -filetypes $types  -initialdir "./" \
		      -title "select humans file..."]

	#if window was closed, proc continue m but no file name was chosed
	if {$file != ""} {
	    if {[loadFile $file]} {
		#we remember file name to save it quickly
		set saveFile $file
	    }
	}

    }


    #Load file containing human informations
    #returns :
    # 1 : OK
    # 0 : Canceled by user / error when deleting
    proc loadFile {filename} {
	global human humanState humanName humanMotion humanDistance humanLeftArm humanRightArm humanLook humanInfos humanlhPos humanrhPos humanhPos humanVel humanllPos humanrlPos humanGenId lastGenId humanPosture

	set answer [MessageDlg::create .msgDlg -message "Do you want to clean the map before adding humans ? " -type yesnocancel]

	if {$answer!=2} {
	    if {$answer==0} {
		#Full delete ( deleted human are not saved)
		if {![removeAll 1 1]} {
		    return 0
		}
	    } 
	    
	    #see saveFile proc to know how informations are saved in the file
	    set f [open $filename "r"]
	    while {[gets $f line] >= 0} {

		set name [lindex $line 0]
		set x [lindex $line 1]
		set y [lindex $line 2]
		set theta [lindex $line 3]
		set id [$Grh2::c create robot $x $y $theta -type xr4000 -tag human]
		set human($id) $name
		set humanState($id) normal
		set id2 [$Grh2::c create text $x $y -text $name -tag humanName]
		set humanName($id) $id2 
		set humanLeftArm($id) [lindex $line 4]
		set humanRightArm($id) [lindex $line 4]
		set humanLook($id) [lindex $line 5]
		set humanMotion($id) [lindex $line 6]
		set humanDistance($id) [lindex $line 7]
		set humanPosture($id) [lindex $line 8]
		set humanlhPos($id,x) [lindex $line 9]
		set humanlhPos($id,y) [lindex $line 10]
		set humanlhPos($id,z) [lindex $line 11]
		set humanrhPos($id,x) [lindex $line 12]
		set humanrhPos($id,y) [lindex $line 13]
		set humanrhPos($id,z) [lindex $line 14]
		set humanhPos($id,x) [lindex $line 15]
		set humanhPos($id,y) [lindex $line 16]
		set humanhPos($id,z) [lindex $line 17]
		set humanVel($id) [lindex $line 18]
		set humanllPos($id,x) [lindex $line 19]
		set humanllPos($id,y) [lindex $line 20]
		set humanllPos($id,z) [lindex $line 21]
		set humanrlPos($id,x) [lindex $line 22]
		set humanrlPos($id,y) [lindex $line 23]
		set humanrlPos($id,z) [lindex $line 24]
		set humanGenId($id) [lindex $line 25]

		if { $lastGenId > $humanGenId($id) } {
		    set lastGenId [expr $humanGenId($id)]
		}
	    }
	    close $f
	    puts "file $filename loaded"
	    return 1
	}  
	return 0
    }





    # saveHumans
    # Save all human infroamtions to curent file (if exists)
    #
    proc saveHumans { } {
	global saveFile

	if {[info exists saveFile]} {
	    saveFile $saveFile
	} else {
	    saveHumansAs
	}
    }

    # saveHumansAs
    # Ask the user where to save all human informations and save them
    # dqwdq
    
    proc saveHumansAs { } {
	global saveFile
	set types {
	    {{humsim Files}        {.humsim}            }
	    {{All Files}        *             }
	}  
	set file [tk_getSaveFile -title "Save as:" -initialdir "./" -filetypes $types]

	if {$file != ""} {
	    if {[saveFile $file]} {
		set saveFile $file
	    }
	}
    }


    #saveFile
    #save file with all humans informations
    #returns 
    # 1 : OK
    # 0 :error
    proc saveFile {filename} {
	global human humanName humanMotion humanDistance humanLeftArm humanRightArm humanLook humanInfos humanlhPos  humanrhPos humanhPos humanVel humanllPos humanrlPos humanGenId humanDeleted humanPosture



	set f [open $filename "w"]
	foreach id [array names human] {
	    #deleted human that are waiting for the delete request to be sent, are not saved.
	    #
	    if {![info exists  humanDeleted($id)]} {		
		puts -nonewline $f "$human($id) "
		puts $f "[$Grh2::c coords $id ] $humanLeftArm($id) $humanRightArm($id) $humanLook($id) $humanMotion($id) $humanDistance($id) $humanPosture($id) $humanlhPos($id,x) $humanlhPos($id,y) $humanlhPos($id,z) $humanrhPos($id,x) $humanrhPos($id,y) $humanrhPos($id,z) $humanhPos($id,x) $humanhPos($id,y) $humanhPos($id,z) $humanVel($id) $humanllPos($id,x) $humanllPos($id,y) $humanllPos($id,z) $humanrlPos($id,x) $humanrlPos($id,y) $humanrlPos($id,z) $humanGenId($id)"
		puts  "$human($id) saved "
	    }
	    
	}
	close $f 
	puts "file $filename saved"
	return 1
    }
    

    #Try to connect to human module
    # Returns OK or message is not OK     
    proc connectToHuman { } {
	global connected
	global tclHost
	
	if {! [info exists connected] } {
	    set connected 0
	}

	#Connect to tclserv
	if { [ catch { connect $tclHost} result ] } {
	    #if we c ara already connected to locahost, we can try to load module if it is not

	    if { [lrange $result 0 1] != "already connected" } {
		puts $result
		set msg "Could not connect to tclserv on jido-arm. Start it first, or checkout your TCLSERV_PORT env"
		puts $msg
		set connected 0
		return $msg
	    }
	}
	if { [ catch { lm human} result ] } {
	    puts $result
	    set msg "Could not load module human. Install it first" 
	    puts $msg
	    set connected 0
	    return $msg
	}
	if { [catch { mboxInit } result ] } { 
	    puts $result
	    set msg "Could not find module human. Start it first"
	    puts $msg
	    set connected 0
	    return $msg
	}
	set connected 1
	return "OK"
	
    }

    #----------------------------------------------------------------------
    ##
    ## send a  request to human Module 
    ##    
    proc sendRequest { rqst { params "" } } {
	global connected

	#if not already connected , try to do it
	if {! [info exists connected] || $connected == 0 } {
	    set answer [connectToHuman]
	    
	    if {$answer != "OK"} {
		return $answer
	    }
	}


	# send request
	#puts "rqst: $rqst params: $params"
	set retCode [catch {
	    eval [concat human::$rqst -raw $params]
	} answer ]
	set message [lindex $answer 0]
	#set Grh2::humsim::rqst "Request $rqst: $message"
	puts "Request to human: $rqst : $message"
	return $answer

    }


    #rotateCoords
    #convert coordinates(x,y) in a new frame with a rotation of theta
    proc rotateCoords { x y theta } {
	upvar $x xf
	upvar $y yf
	set xi $xf
	set yi $yf

	set xf [expr $xi*cos(-$theta)+ $yi *sin(-$theta) ]
	set yf [expr $yi*cos(-$theta)- $xi *sin(-$theta) ]

    }


    #  #pos_to_abs
    #Convert (x,y) in absolute . (bx,by,bth) is the old frame absolute coordinates
    proc pos_to_abs {x y  bx by bth} {

	upvar $x hx 
	upvar $y hy 

	rotateCoords hx hy $bth

	set hx [expr $hx + $bx]
	set hy [expr $hy + $by]

    }

    #pos_to_rel
    #Convert (x,y) in relative to the new frame. (bx,by,bth) is the new frame absolute coordinates
    proc pos_to_rel {x y  bx by bth} {

	upvar $x hx 
	upvar $y hy 
	set rot [expr -$bth]

	rotateCoords hx hy $rot

	set hx [expr $hx - $bx]
	set hy [expr $hy - $by]

    }


    #sendInfos
    #Prepare requests to send all Humans infos to Human module
    proc sendInfos { } { 
	global human humanName humanMotion humanDistance humanLeftArm humanRightArm humanLook humanInfos humanlhPos  humanrhPos humanhPos humanVel humanllPos humanrlPos humanGenId humanDeleted humanPosture

	#not used anymore
	#we just wait  answer and diplay a dialog box in case of error  for the first request
	#it should work for others if it works for it. But if it is not the case
	# error message will be printed in the console
	#set answer [::Grh2::humsim::sendRequest DisableAllHuman ]
	# if {[lindex $answer 0] != "OK" } {
	#MessageDlg::create .msgDlg -message "Error : can not send request : $answer " -type ok -icon error
	#error now : de not try to send others request
	#return 0; 
	#}

	set index 0
	foreach id [array names human] {
	    if {$humanGenId($id) < 0 } {		    
		if { [info exists humanDeleted($id)] } {
		    after 1 "::Grh2::humsim::sendRequest DeleteHumanId {$humanGenId($id)}"
		    #now we have sent the request, we can delete the human totally
		    removeHumanId $Grh2::c $id 1 1
		} else {
		    
		    #set params "GEN_TRUE humanGenId($id) $human($id) HUMAN_DISTANCE_$humanDistance($id) HUMAN_MOTION_$humanMotion($id) HUMAN_LOOK_$humanLook($id) HUMAN_ARM_$humanLeftArm($id) HUMAN_ARM_$humanRightArm($id)"

		    #set answer [::Grh2::humsim::sendRequest SetHumanState $params ]  
		    #Do not wait the answer to send other request it is to long ...
		    #after 1  "::Grh2::humsim::sendRequest SetHumanState {$params}"

		    set coord [$Grh2::c coords $id]
		    #puts $coord
		    set xm [Grh2::x_pixel_to_m [lindex $coord 0]]
		    set ym [Grh2::y_pixel_to_m  [lindex $coord 1]]
		    
		    

		    set yawm [lindex $coord 2]
		    #puts "$yawm  0 0 $xm $ym 0 GEN_TRUE"

		    set humanInfos($id,pos) "$yawm 0 0 $xm $ym 0 GEN_TRUE"

		    #convert head in absolute  
		    set x [expr $humanhPos($id,x)]
		    set y [expr $humanhPos($id,y)] 
		    pos_to_abs x y $xm $ym $yawm

		    #set x [expr $humanhPos($id,x)]
		    #set y [expr $humanhPos($id,y)]
		    #rotateToAbsolute $x $y $yawm
		    #set x [expr $x + $xm]
		    #set y [expr $x + $ym]
		    

		    set humanInfos($id,Hpos)  "GEN_TRUE 0 0 0 $x $y $humanhPos($id,z)  "
		    puts " head abs : $x $y"

		    #convert left hand in absolute  
		    set x [expr $humanlhPos($id,x)]
		    set y [expr $humanlhPos($id,y)] 
		    pos_to_abs x y $xm $ym $yawm

		    set humanInfos($id,LHpos)  "0 0 0 $x $y $humanlhPos($id,z) GEN_TRUE "


		    #convert right hand in absolute 
		    set x [expr $humanrhPos($id,x) ]
		    set y [expr $humanrhPos($id,y) ]
		    pos_to_abs x y $xm $ym $yawm

		    
		    set humanInfos($id,RHpos)  " GEN_TRUE 0 0 0 $x $y  $humanrhPos($id,z) "
		    
		    
		    #convert left leg in absolute   
		    set x [expr $humanllPos($id,x)]
		    set y [expr $humanllPos($id,y)] 
		    pos_to_abs x y $xm $ym $yawm

		    
		    set humanInfos($id,LLpos)  "0 0 0 $x $y  $humanllPos($id,z) GEN_TRUE "

		    #convert right leg in absolute 
		    set x [expr $humanrlPos($id,x)]
		    set y [expr $humanrlPos($id,y)] 
		    pos_to_abs x y $xm $ym $yawm

		    
		    set humanInfos($id,RLpos)  " GEN_TRUE 0 0 0 $x $y $humanrlPos($id,z) "





		    set params "GEN_TRUE $humanGenId($id) $human($id) $humanDistance($id) $humanMotion($id) $humanLook($id) $humanLeftArm($id) $humanRightArm($id) $humanPosture($id) 0\
$humanInfos($id,pos) GEN_TRUE $humanVel($id) 0.0 GEN_FALSE $humanInfos($id,Hpos) $humanInfos($id,LHpos) $humanInfos($id,RHpos) $humanInfos($id,LLpos) $humanInfos($id,RLpos) "
		    #puts $params
		    after 1 "::Grh2::humsim::sendRequest SetHuman {$params}"
		    #set answer [::Grh2::humsim::sendRequest SetHumanInfos $params ]
		    #puts "Send request to human module : $answer"
		}
	    }
	    set index [expr $index + 1]
	    
	}
	
	#ok
	return 1;


    }




    proc loadFromHuman {} {
	global human humanName humanMotion humanDistance humanLeftArm humanRightArm humanLook humanInfos humanlhPos  humanrhPos humanhPos humanVel humanllPos humanrlPos humanGenId humanDeleted humanState stateColor humanPosture
	global picoHost
	global  robId robNameId

	
	variable posterBase "http://$picoHost:8080/human?get="
	
	#Get robot position
	set url $posterBase
	append url "HumanOtherModulesInfosrobotCurentPos"


	if {[catch {xml::getDoc $url} doc] != 0} {
	    error "human::update: $doc"
	}
	set rX  [Grh2::x_m_to_pixel [[$doc selectNodes "//euler/x/text()"] data]]
	set rY  [Grh2::y_m_to_pixel [[$doc selectNodes "//euler/y/text()"] data]]
	set rYaw  [[$doc selectNodes "//euler/yaw/text()"] data]

	if [info exists robId] {
	    $Grh2::c delete $robId
	}
	if [info exists robNameId] {
	    $Grh2::c delete $robNameId
	}

	
	set robId [$Grh2::c create robot $rX $rY $rYaw -type xr4000 -tag robot]
	$Grh2::c itemconfigure $robId -fill purple
	set robNameId [$Grh2::c create text $rX $rY -text Rob -tag robotName]
	$Grh2::c itemconfigure $robNameId -fill purple
		
	#End robot position


	#Get all humans
	#first, we remove all human from the map 
	removeAll 1 

	set url $posterBase
	append url "HumanAllInformations"


	if {[catch {xml::getDoc $url} doc] != 0} {
	    error "human::update: $doc"
	}
	
	set nbreHuman [[$doc selectNodes "//nbrHumans/text()"] data]	
	puts "NMBRE :$nbreHuman"
	
	for { set i 0 } { $i <  $nbreHuman} { incr i } { 
	    
	    
	    ### PRECISES INFO ###
	    #HUMAN POSITION ( on the ground - 2D )
	    set hx  [[$doc selectNodes "//humanInfosAll/humanInfos.$i/pos/main/x/text()"] data]
	    set hy  [[$doc selectNodes "//humanInfosAll/humanInfos.$i/pos/main/y/text()"] data]
	    set px [Grh2::x_m_to_pixel $hx]
	    set py [Grh2::y_m_to_pixel $hy]
	    set htheta [[$doc selectNodes "//humanInfosAll/humanInfos.$i/pos/main/yaw/text()"] data]

	    set id [$Grh2::c create robot $px $py $htheta -type xr4000 -tag human]
	  
	    set humanState($id) normal
	  
	    
	#define x_m_to_pixel(x) ((x) * grh2Scale)
		#define y_m_to_pixel(x) (-(x) * grh2Scale)
	    # 	#HEAD POSITION 
	    set humanhPos($id,x)  [[$doc selectNodes "//humanInfosAll/humanInfos.$i/headPos/x/text()"] data]
	    set humanhPos($id,y)  [[$doc selectNodes "//humanInfosAll/humanInfos.$i/headPos/y/text()"] data]
	    set humanhPos($id,z) [[$doc selectNodes "//humanInfosAll/humanInfos.$i/headPos/z/text()"] data]
	    #convert head in relative
	    pos_to_rel humanhPos($id,x) humanhPos($id,y) $hx $hy $htheta




	    #set yaw [[$doc selectNodes "//humanInfosAll/humanInfos.$i/headPos/yaw/text()"] data]
	    #set pitch [[$doc selectNodes "//humanInfosAll/humanInfos.$i/headPos/pitch/text()"] data]
	    #set roll [[$doc selectNodes "//humanInfosAll/humanInfos.$i/headPos/roll/text()"] data]

	    # 	#LEFT HAND POSITION 
	    set humanlhPos($id,x)  [[$doc selectNodes "//humanInfosAll/humanInfos.$i/leftHandPos/x/text()"] data]
	    set humanlhPos($id,y)   [[$doc selectNodes "//humanInfosAll/humanInfos.$i/leftHandPos/y/text()"] data]
	    set humanlhPos($id,z)   [[$doc selectNodes "//humanInfosAll/humanInfos.$i/leftHandPos/z/text()"] data]
	    # set yaw [[$doc selectNodes "//humanInfosAll/humanInfos.$i/leftHandPos/yaw/text()"] data]
	    # set pitch [[$doc selectNodes "//humanInfosAll/humanInfos.$i/leftHandPos/pitch/text()"] data]
	    #set roll [[$doc selectNodes "//humanInfosAll/humanInfos.$i/leftHandPos/roll/text()"] data]
	 
	    #convert left hand in relative
	    pos_to_rel humanlhPos($id,x) humanlhPos($id,y) $hx $hy $htheta
	    
	    # 	#RIGHT HAND POSITION 
	    set humanrhPos($id,x) [[$doc selectNodes "//humanInfosAll/humanInfos.$i/rightHandPos/x/text()"] data]
	    set humanrhPos($id,y) [[$doc selectNodes "//humanInfosAll/humanInfos.$i/rightHandPos/y/text()"] data]
	    set humanrhPos($id,z) [[$doc selectNodes "//humanInfosAll/humanInfos.$i/rightHandPos/z/text()"] data]
	    #set yaw [[$doc selectNodes "//humanInfosAll/humanInfos.$i/rightHandPos/yaw/text()"] data]
	    #set pitch [[$doc selectNodes "//humanInfosAll/humanInfos.$i/rightHandPos/pitch/text()"] data]
	    #set roll [[$doc selectNodes "//humanInfosAll/humanInfos.$i/rightHandPos/roll/text()"] data]

	    #convert right hand in relative
	    pos_to_rel humanrhPos($id,x) humanrhPos($id,y) $hx $hy $htheta
	    


	    
	    
	    

	    
	    # 	#LEFT LEG POSITION 
	    set humanllPos($id,x) [[$doc selectNodes "//humanInfosAll/humanInfos.$i/leftLegPos/x/text()"] data]
	    set humanllPos($id,y) [[$doc selectNodes "//humanInfosAll/humanInfos.$i/leftLegPos/y/text()"] data]
	    set humanllPos($id,z) [[$doc selectNodes "//humanInfosAll/humanInfos.$i/leftLegPos/z/text()"] data]
	    #set yaw [[$doc selectNodes "//humanInfosAll/humanInfos.$i/leftLegPos/yaw/text()"] data]
	    #set pitch [[$doc selectNodes "//humanInfosAll/humanInfos.$i/leftLegPos/pitch/text()"] data]
	    #set roll [[$doc selectNodes "//humanInfosAll/humanInfos.$i/leftLegPos/roll/text()"] data]

	    #convert left leg in relative
	    pos_to_rel humanllPos($id,x) humanllPos($id,y) $hx $hy $htheta
	    
	    
	    
	    # 	#RIGHT LEG POSITION 
	    set humanrlPos($id,x)  [[$doc selectNodes "//humanInfosAll/humanInfos.$i/rightLegPos/x/text()"] data]
	    set humanrlPos($id,y) [[$doc selectNodes "//humanInfosAll/humanInfos.$i/rightLegPos/y/text()"] data]
	    set humanrlPos($id,z) [[$doc selectNodes "//humanInfosAll/humanInfos.$i/rightLegPos/z/text()"] data]
	    #set yaw [[$doc selectNodes "//humanInfosAll/humanInfos.$i/rightLegPos/yaw/text()"] data]
	    #set pitch [[$doc selectNodes "//humanInfosAll/humanInfos.$i/rightLegPos/pitch/text()"] data]
	    #set roll [[$doc selectNodes "//humanInfosAll/humanInfos.$i/rightLegPos/roll/text()"] data]

	    #convert right leg in relative
	    pos_to_rel humanrlPos($id,x) humanrlPos($id,y) $hx $hy $htheta
	    
	    # 	#VELOCITY
	    set humanVel($id) [[$doc selectNodes "//humanInfosAll/humanInfos.$i/vel/text()"] data]

	    
	    # DISTANCE (this wille be computed by human)
	    #set p($index,$i,dist) [[$doc selectNodes "//humanInfosAll/humanInfos.$i/dist/text()"] data]
	    
	    
	    ### STATE INFOS ###
	    #VALID ?
	    #set p($index,$i,st_valid) [[$doc selectNodes "//humanStateAll/humanState.$i/valid/text()"] data]
	    #NAME
	   
	    if {[ catch {set name [[$doc selectNodes "//humanStateAll/humanState.$i/name/name/text()"] data] } ] != 0} { 
		#if name has not been set, it is null on the poster,
		#so we still want to set our variable to null in order to avoid futurs errors
		set name ""	
	    } 
	    set id2 [$Grh2::c create text $px $py -text $name -tag humanName]
	    set humanName($id) $id2 
	    set human($id) $name

	    #ID
	    set humanGenId($id) [[$doc selectNodes "//humanStateAll/humanState.$i/id/text()"] data]
	    #DISTANCE
	    set humanDistance($id) [[$doc selectNodes "//humanStateAll/humanState.$i/distance/text()"] data]
	    #MOTION
	    set humanMotion($id) [[$doc selectNodes "//humanStateAll/humanState.$i/motion/text()"] data]
	    #LOOK
	    set humanLook($id) [[$doc selectNodes "//humanStateAll/humanState.$i/look/text()"] data]
	    #ARM
	    set humanLeftArm($id) [[$doc selectNodes "//humanStateAll/humanState.$i/leftArm/text()"] data]
	    set humanRightArm($id) [[$doc selectNodes "//humanStateAll/humanState.$i/rightArm/text()"] data]
	    #POSTURE
	    set humanPosture($id) [[$doc selectNodes "//humanStateAll/humanState.$i/posture/text()"] data]

	    if {$humanGenId($id) > 0 } {
		set humanState($id) real
	    }
	    $Grh2::c itemconfigure $id -fill $stateColor($humanState($id))
	}
    }
}


#----------------------------------------------------------------------
##
## Go 
##


# load resources
Grh2::getResources $::Grh2::dir/app-defaults/Graphique
# Creation fenetre 
Grh2::humsim::mainWindow
wm title . "Grh2 - humsim"
wm deiconify .

# define an icon
toplevel .icon
image create photo icon 
icon read $::Grh2::dir/icons/diligent.gif
label .icon.l -image icon
pack .icon.l
wm iconwindow . .icon
wm iconname . humsim


# default mode:edit 
Grh2::humsim::editMode

# Default colors for the possible states of a segment

set stateColor(normal) grey50
#set stateColor(current) black
set stateColor(current) Green
set stateColor(selected) blue
set stateColor(real) orange

#Starting genom ID ( decrement)
set lastGenId -100

Grh2::segkit::load gs.map

Grh2::updateScrollBars

Grh2::humsim::PrepareContextualMenu


