#
# Copyright (c) 2007 CNRS/LAAS
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
#
# Matthieu Herrb - Fri Jan 19 2007
#
# $LAAS: xml.tcl,v 1.1 2007/08/28 09:44:37 treygner Exp $
#
package require http
package require tdom

namespace eval xml {
    # get the XML doc tree from an HTTP server
    proc getDoc { poster } { 

	if {[catch {http::geturl "$poster"} token] != 0} {
	    error "getDoc: $token"
	}
	if {[http::status $token] != "ok"} {
	    set message [http::status $token]
	    http::cleanup $token
	    error "getDoc: bad status $message"
	}
	if {![string match *OK* [http::code $token]]} {
	    set message [http::code $token]
	    http::cleanup $token
	    error "getDoc: bad return code $message"
	}
	set xml [http::data $token]
	set dom [dom parse $xml]
	return  [$dom documentElement]
    }
    # Read the XML doc tree from a file
    proc readDoc { file } {
	if {[catch {set f [open $file r]} msg] != 0} {
	    error "open: $msg"
	}
	while {![eof $f]} {
	    append xml [gets $f]
	}
	close $f
	set dom [dom parse $xml]
	return [$dom documentElement]
    }
}
package provide xml 1.0

